/* Message list header time simple parser.
   Copyright (C) 2019 Free Software Foundation, Inc.
   Written by Markéta Calábková <mcalabkova@suse.cz>, 2019.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

#ifndef _MSGL_AGE_H
#define _MSGL_AGE_H

#include "message.h"

/* Helper function to compare the ages, needed by qsort. */
int
       msgdomain_compare_ages (const void *, const void *);

/* Simple function to modify intern ordering of files 
 * such that the newer file comes first. In fact it just calls qsort. */
void
       msgdomain_sort_by_ages (msgdomain_list_ty **, size_t);

/* Parse dates in PO-Revision-Date: and store them inside the structure. */
void
       msgdomain_read_ages (msgdomain_list_ty *);

#endif
